//
//  XSPEC12  November 2003
//
//
        
#include "XSUser/Global/Global.h"
#include "XSUser/Global/XSGlobal.h"
#include "XSFit/Fit/Fit.h"        
#include "XSUtil/Utils/XSutility.h"
#include "XSUtil/Parse/XSparse.h"
#include "XSContainer.h"
#include "XSstreams.h"
#include "xsTypes.h"

int
XSGlobal::xsRenorm(ClientData cdata,Tcl_Interp* tclInterp,int objc, Tcl_Obj* CONST  objv[])
{
        using XSContainer::fit;
        string cmd = string(static_cast<char*>(cdata));
        if (objc == 1)
        {
                try
                {
                        fit->renormalize();      
                        fit->Update();                
                }
                catch (Fit::CantInitialize)
                {
                        return globalData->autoSave(TCL_ERROR);
                }
        }
        else // ? | NONE | AUTO | PREFIT
        {
            
             string arg = Tcl_GetString(objv[1]);
             arg = XSutility::lowerCase(arg);
             static const string onlyExplicit ("none");
             static const string automatic ("auto");
             static const string beforeFit ("prefit");
             
             // these are diagnostics, not error messages.
             if (automatic.find(arg) != XSparse::NOTFOUND() )
             {
                        fit->renormType(Fit::AUTO); 
                        tcout << " Renormalization will be performed automatically\n";     
             }
             else if (onlyExplicit.find(arg) !=  XSparse::NOTFOUND() )
             {
                        fit->renormType(Fit::NONE); 
                        tcout << " Implicit renormalizations disabled - use renorm command\n";                          
             }
             else if (beforeFit.find(arg) !=  XSparse::NOTFOUND() )
             {
                        fit->renormType(Fit::PREFIT); 
                        tcout << " Renormalizations only performed before fitting\n" ;                          
             }
             else
             {
                printDocs(cmd.c_str(),"?");
                if ( arg[0] != '?' ) return globalData->autoSave(TCL_ERROR);          
             }                 
        }
        tcout << std::flush;
        return globalData->autoSave(TCL_OK);
}
